var Emoticons = new Array();
Emoticons[":@"] = "angry.png";
Emoticons[":D"] = "bigsmile.png";
Emoticons[":S"] = "confused.png";
Emoticons[":|"] = "disappointed.png";
Emoticons[":)"] = "happy.png";
Emoticons[":("] = "sad.png";
Emoticons[":P"] = "stickouttongue.png";
Emoticons[":O"] = "surprised.png";
Emoticons[";)"] = "wink.png";

var prefObserver = {
  observe : function(subject, topic, data) {
    if (topic == "nsPref:changed") {
      data = data.replace("extensions.msnmsgr.", "");
      if (data.substr(0, 4) == "font") {
        window.MMS_FN = prefBranch.getCharPref("font.name");
        window.MMS_CO = prefBranch.getCharPref("font.color");
        window.MMS_EF_B = prefBranch.getBoolPref("font.bold");
        window.MMS_EF_I = prefBranch.getBoolPref("font.italic");
        window.MMS_EF_U = prefBranch.getBoolPref("font.underline");
        window.MMS_EF_S = prefBranch.getBoolPref("font.strike");
        fontChanged();
      }
      else {
        window.showEmoticons = prefBranch.getBoolPref("show-emoticons");
        window.behindRouter = prefBranch.getBoolPref("behind-router");
      }
    }
  },
  QueryInterface : function (aIID) {
    if (aIID.equals(Components.interfaces.nsIObserver) || 
      aIID.equals(Components.interfaces.nsISupports) ||
      aIID.equals(Components.interfaces.nsISupportsWeakReference))
      return this;
      throw Components.results.NS_NOINTERFACE;
  }
}

function addPrefObserver() {
  var pbi = prefService.QueryInterface(nsIPrefBranchInternal);
  pbi.addObserver("extensions.msnmsgr.show-emoticons", prefObserver, true);
  pbi.addObserver("extensions.msnmsgr.behind-router", prefObserver, true);
  pbi.addObserver("extensions.msnmsgr.font.name", prefObserver, true);
  pbi.addObserver("extensions.msnmsgr.font.color", prefObserver, true);
  pbi.addObserver("extensions.msnmsgr.font.bold", prefObserver, true);
  pbi.addObserver("extensions.msnmsgr.font.italic", prefObserver, true);
  pbi.addObserver("extensions.msnmsgr.font.underline", prefObserver, true);
  pbi.addObserver("extensions.msnmsgr.font.strike", prefObserver, true);
}

function onSessionLoad() {
  window.bundle = getStringBundle("chrome://msnmsgr/locale/session.properties");
  window.client = window.arguments[0].client;
  var contactID = window.arguments[0].contactID;
  window.session = new MSNSession(window.client, contactID);
  if (typeof(window.arguments[1]) != "undefined") {
    var host = window.arguments[1].host;
    var port = window.arguments[1].port;
    var cki = window.arguments[1].cki;
    var sessionID = window.arguments[1].sessionID;
    window.session.answer(host, port, cki, sessionID);
  }
  else {
    window.client.getSession(window.session);
  }
  document.title = contactID;
  var noMessagesReceived = window.bundle.GetStringFromName("noMessagesReceived");
  document.getElementById("status-bar-main").firstChild.setAttribute("label", noMessagesReceived);
  window.lastMsgRcvTime = null;
  window.showEmoticons = getPref("getBoolPref", "show-emoticons", true);
  window.behindRouter = getPref("getBoolPref", "behind-router", false);
  window.MMS_FN = getPref("getCharPref", "font.name", "Arial");
  window.MMS_CO = getPref("getCharPref", "font.color", "#000000");
  window.MMS_EF_B = getPref("getBoolPref", "font.bold", false);
  window.MMS_EF_I = getPref("getBoolPref", "font.italic", false);
  window.MMS_EF_U = getPref("getBoolPref", "font.underline", false);
  window.MMS_EF_S = getPref("getBoolPref", "font.strike", false);
  addPrefObserver();
  contactsChanged();
  fontChanged();
  changeFontSize("small");
  document.getElementById("message").focus();
}

function onSessionUnload() {
  if (typeof(window.fileStream) != "undefined") {
    window.fileStream.close();
  }
  window.session.close();
}

function changeFontSize(class) {
  document.getElementById("chat-panel").contentDocument.body.setAttribute("class", class);
  document.getElementById("message").setAttribute("class", class);
}

function inviteContact() {
  window.openDialog("chrome://msnmsgr/content/invitecontact.xul", "_blank", "chrome",
    {client: window.client, session: window.session} );
}

function logConversation() {
  var logging = document.getElementById("window-log").getAttribute("checked");
  if (logging == "true") {
    var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
    file.append("logs");
    if (!file.exists() || !file.isDirectory() ) {
      file.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0664);
    }
    file.append(window.session.getFirstContactID() + " " + getTimeStamp('', '') + ".log");
    var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
    try {
      foStream.init(file, 0x02 | 0x08 | 0x10, 0664, 0);
      window.fileStream = foStream;
      showNotificationMessage("logOn", '');
    }
    catch (ex) {
      showNotificationMessage("logFailed", '');
    }
  }
  else {
    window.fileStream.close();
    delete window.fileStream;
    showNotificationMessage("logOff", '');
  }
}

function onContextMenu() {
  var element = document.popupNode;
  var isLink = element instanceof HTMLAnchorElement;
  document.getElementById("cmd-copy").hidden = isLink;
  document.getElementById("cmd-copyLink").hidden = !isLink;
}

function sendFile() {
  var filePicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
  filePicker.init(window, window.bundle.GetStringFromName("chooseFile"), nsIFilePicker.modeOpen);
  var filePickResult = filePicker.show();
  if (filePickResult == nsIFilePicker.returnOK) {
    window.session.initTransfer(filePicker.file, window.behindRouter);
  }
}

function sendIM(e) {
  if ((e.type == "command") || (e.type == "keypress" && e.keyCode == 13 && e.shiftKey == false)) {
    var msgText = document.getElementById("message").value;
    if (msgText != '') {
      window.document.getElementById("message").value = '';
      var msgNode = createMessageNode(window.opener.getNickname(), msgText, window.msgStyle, true);
      appendAndScroll(msgNode);
      if (typeof(window.fileStream) != "undefined") {
        logIM(window.client.passport, msgText);
      }
      window.session.sendIM(uniConvertFrom(msgText), window.MMS);
    }
    e.preventDefault();
  }
  else {
    window.session.handleTyping();
  }
}

window.answerIncomingSession = function(contactID, host, port, cki, sessionID) {
  window.session.close();
  window.session.reset();
  window.session.answer(host, port, cki, sessionID);
}

function askUser(topic, question) {
  var flags = promptService.STD_YES_NO_BUTTONS + promptService.BUTTON_POS_1_DEFAULT;
  var check = {value: false};
  var result = promptService.confirmEx(window, topic, question, flags, '', '', '', null, check);
  var answer;
  result == 1 ? answer = false : answer = true;
  return answer;
}

function catchLink(e) {
  var href = this.href;
  var ioservice = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
  var extps = Components.classes["@mozilla.org/uriloader/external-protocol-service;1"].getService(Components.interfaces.nsIExternalProtocolService);
  var uriToOpen = ioservice.newURI(href, null, null);
  extps.loadURI(uriToOpen, null);
  e.preventDefault();
}

function createNewSession() {
  window.session.close();
  window.session.reset();
  window.client.getSession(window.session);
}

window.contactChanged = function(contactID, nickname, status) {
  if (window.session) {
    window.session.contactChanged(contactID, nickname, status);
  }
}

function contactsChanged() {
  var chatParticipantsBar = document.getElementById("chat-participants");
  var talkingToString = window.bundle.GetStringFromName("sendMessageToLabel") + "  ";
  var contacts = window.session.getContacts();
  var contactsString = '';
  var statusColor = '';
  for (var i = 0; i < contacts.length; i++) {
    var status = window.opener.getStatusString(contacts[i].status);
    contactsString += contacts[i].nickname + " (" + status + ") <" + contacts[i].email + ">, ";
  }
  contactsString = contactsString.substr(0, contactsString.length - 2);
  if (contacts.length == 1 && contacts[0].status != "NLN") {
    statusColor = "gold";
  }
  else {
    statusColor = "lightblue";
  }
  chatParticipantsBar.firstChild.nodeValue = talkingToString + contactsString;
  chatParticipantsBar.style.backgroundColor = statusColor;
}

function fontChanged() {
  var mms = "FN=" + escape(window.MMS_FN) + "; EF=";
  if (window.MMS_EF_B)
    mms += "B";
  if (window.MMS_EF_U)
    mms += "U";
  if (window.MMS_EF_I)
    mms += "I";
  if (window.MMS_EF_S)
    mms += "S";
  mms += "; CO=" + swapRedBlue(window.MMS_CO.substr(1, 6)) + "; CS=0; PF=00";
  window.MMS = mms;
  window.msgStyle = convertMMStoStyle(window.MMS);
  document.getElementById("message").setAttribute("style", window.msgStyle);
}

window.getContactCount = function() {
  return window.session.getContactCount();
}

window.getFirstContactID = function() {
  return window.session.getFirstContactID();
}

function receiveFile(fileName, fileSize) {
  var file = null;
  var sizeInKiloBytes = fileSize + " " + window.bundle.GetStringFromName("kiloByte");
  var topic = window.bundle.GetStringFromName("transfer");
  var question = window.bundle.GetStringFromName("acceptFile1").replace("%S", fileName)
    + window.bundle.GetStringFromName("acceptFile2").replace("%S", sizeInKiloBytes);
  var accept = askUser(topic, question);
  if (accept == true) {
    var filePicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
    filePicker.init(window, "Choose where you want to save the file", nsIFilePicker.modeGetFolder);
    var filePickResult = filePicker.show();
    if (filePickResult == nsIFilePicker.returnOK) {
      file = filePicker.file;
      file.append(fileName);
    }
  }
  return file;
}

window.reportTransferResult = function(result, id, fileName) {
  window.session.transferDone(result, id, fileName);
}

function sessionClosed() {
  showNotificationMessage("closedMessage", '');
  document.getElementById("message").disabled = true;
  document.getElementById("btn-send").disabled = true;
}

function showIM(from, fromID, msgText, mms) {
  var timeStamp = getTimeStamp("/", ":");
  timeStamp = timeStamp.substr(0, timeStamp.length - 3);
  window.lastMsgRcvTime = timeStamp;
  if (typeof(window.fileStream) != "undefined") {
    logIM(fromID, msgText);
  }
  var style = '';
  if (typeof(mms) == "string") {
    style = convertMMStoStyle(mms);
  }
  var msgNode = createMessageNode(from, msgText, style, false);
  appendAndScroll(msgNode);
}

function showNotificationMessage(label, replaceStr) {
  var msg = window.bundle.GetStringFromName(label);
  var msgNode = window.document.createElementNS(XHTML, "div");
  if (replaceStr != '') {
    msg = msg.replace("%S", replaceStr);
  }
  msgNode.setAttribute("class", "NotificationMessage");
  var textNode = window.document.createTextNode(msg);
  msgNode.appendChild(textNode);
  appendAndScroll(msgNode);
}

function showTypingContacts(contacts, count) {
  var statusMsg = '';
  switch (count) {
    case 0:
      if (window.lastMsgRcvTime != null) {
        statusMsg = window.bundle.GetStringFromName("lastMessageReceived").replace("%S", window.lastMsgRcvTime);
      }
      else {
        statusMsg = window.bundle.GetStringFromName("noMessagesReceived");
      }
      break;
    case 1:
      var typingMsg = window.bundle.GetStringFromName("isTyping");
      statusMsg = typingMsg.replace("%S", contacts);
      break;
    default:
      var typingMsg = window.bundle.GetStringFromName("areTyping");
      statusMsg = typingMsg.replace("%S", contacts);
      break;
  }
  document.getElementById("status-bar-main").firstChild.setAttribute("label", statusMsg);
}

function appendAndScroll(node) {
  var panel = document.getElementById("chat-panel").contentDocument;
  var panelView = panel.defaultView;
  var scroll = (panelView.scrollY == panelView.scrollMaxY);
  panel.body.appendChild(node);
  if (scroll == true) {
    panelView.scroll(0, panelView.scrollMaxY);
  }
}

function convertMMStoStyle(mms) {
  var params = new Array();
  var fields = mms.split("; ");
  var font = '';
  var fontFamily = '';
  var style = '';
  for (field in fields) {
    var param = fields[field].split("=");
    params[param[0].toUpperCase()] = param[1];
  }
  if (typeof(params["FN"]) != "undefined") {
    font = "\'" + unescape(params["FN"]) + "\'";
  }
  if (typeof(params["EF"]) != "undefined") {
    for (var i = 0; i < params["EF"].length; i++) {
      switch (params["EF"].substr(i, 1)) {
        case "B":
          style += "font-weight: bold; ";
          break;
        case "I":
          style += "font-style: italic; ";
          break;
        case "U":
          style += "text-decoration: underline; ";
          break;
        case "S":
          style += "text-decoration: line-through; ";
          break;
      }
    }
  }
  if (typeof(params["CO"]) != "undefined") {
    var bgr = "000000".substr(0, 6 - params["CO"].length) + params["CO"];
    style += "color: #" + swapRedBlue(bgr) + "; ";
  }
  if (typeof(params["PF"]) != "undefined") {
    switch (params["PF"].substr(0, 1)) {
      case "1":
        fontFamily = "serif";
        break;
      case "2":
        fontFamily = "sans-serif";
        break;
      case "3":
        fontFamily = "monospace";
        break;
      case "4":
        fontFamily = "cursive";
        break;
      case "5":
        fontFamily = "fantasy";
        break;
    }
  }
  if (typeof(params["RL"]) != "undefined" && params["RL"] == "1") {
    style += "text-align: right; ";
  }
  if (font != '' && fontFamily != '') {
    style += "font-family: " + font + ", " + fontFamily + "; ";
  }
  else {
    if (!(font == '' && fontFamily == '')) {
      style += "font-family: " + font + fontFamily + "; ";
    }
  }
  return style;
}

function createMessageNode(from, msgText, style, myMsg) {
  var msgNode = window.document.createElementNS(XHTML, "div");
  var fromNode = window.document.createElementNS(XHTML, "div");
  var fromTextNode = window.document.createTextNode(from + ":");
  var msgTextNode = createMessageTextNode(msgText);
  fromNode.appendChild(fromTextNode);
  if (myMsg == true) {
    fromNode.setAttribute("class", "From FromMe");        
  }
  else {
    fromNode.setAttribute("class", "From");
  }
  msgTextNode = createMessageTextNode(msgText, msgTextNode);
  msgTextNode.setAttribute("class", "message");
  msgTextNode.setAttribute("style", style);
  msgNode.appendChild(fromNode);
  msgNode.appendChild(msgTextNode);
  msgNode.setAttribute("class", "InstantMessage");
  return msgNode;
}

function createMessageTextNode(msgText) {
  var msgTextNode = window.document.createElementNS(XHTML, "div");
  var openEyesEmoticons = "@)(DS|PO";
  var start = 0;
  for (var i = 0; i < msgText.length; i++) {
    var letter = msgText.charAt(i);
    switch (letter) {
      case ":":
        if (window.showEmoticons == true) {
          var letter2 = msgText.charAt(i + 1).toUpperCase();
          if (openEyesEmoticons.indexOf(letter2) >= 0 && letter2 != '') {
            addText(msgText.substr(start, i - start));
            addEmoticon(":" + letter2);
            start = i + 2;
          }
        }
        break;
      case ";":
        if (window.showEmoticons == true) {
          if (msgText.charAt(i + 1) == ")") {
            addText(msgText.substr(start, i - start));
            addEmoticon(";)");
            start = i + 2;
          }
        }
      case "h":
        i++;
        if (msgText.substr(i, 6) == "ttp://") {
          var httpEndPos = msgText.indexOf("\n", i);
          addText(msgText.substr(start, i - start - 1));
          if (httpEndPos == -1) {
            httpEndPos = msgText.indexOf(" ", i);
            if (httpEndPos == -1) {
              var link = "h" + msgText.substr(i, msgText.length - i);
              addLink(link);
              i = msgText.length;
              start = msgText.length;
            }
            else {
              var link = "h" + msgText.substr(i, httpEndPos - i);
              addLink(link);
              i = httpEndPos;
              start = httpEndPos;
            }
          }
          else {
            var link = "h" + msgText.substr(i, httpEndPos - i);
            addLink(link);
            i = httpEndPos;
            start = httpEndPos;
          }
        }
        break;
    }
  }
  if (start != i) {
    addText(msgText.substr(start, i - start));
  }
    
  function addText(t) {
    var textNode = window.document.createTextNode(t);
    msgTextNode.appendChild(textNode);
  }
  function addEmoticon(e) {
    var imageNode = window.document.createElementNS(XHTML, "img");
    imageNode.setAttribute("src", "chrome://msnmsgr/skin/emoticons/" + Emoticons[e]);
    imageNode.setAttribute("alt", e);
    imageNode.setAttribute("width", 19);
    imageNode.setAttribute("height", 19);
    msgTextNode.appendChild(imageNode);
  }
  function addLink(l) {
    var linkNode = window.document.createElementNS(XHTML, "a");
    var textNode = window.document.createTextNode(l);
    linkNode.setAttribute("href", l);
    linkNode.appendChild(textNode);
    msgTextNode.appendChild(linkNode);
    linkNode.addEventListener("click", catchLink, true);
  }

  return msgTextNode;
}

function getTimeStamp(sep1, sep2) {
  var d = new Date();
  var hours = ensureTwoDigits(d.getHours());
  var minutes = ensureTwoDigits(d.getMinutes());
  var seconds = ensureTwoDigits(d.getSeconds());
  var timeStamp = d.getFullYear() + sep1 + (d.getMonth() + 1) + sep1 + d.getDate() + " ";
  timeStamp += hours + sep2 + minutes + sep2 + seconds;

  function ensureTwoDigits(number) {
    var ensuredNumber = '';
    if (number > 9) {
      ensuredNumber = number;
    }
    else {
      ensuredNumber = "0" + number;
    }
    return ensuredNumber;
  }

  return timeStamp;
}

function logIM(contactID, msgText) {
  line = uniConvertFrom("[" + getTimeStamp("/", ":") + "] <" + contactID + "> " + msgText + '\r\n');
  window.fileStream.write(line, line.length);
}

function swapRedBlue(color) {
  return color.substr(4, 2) + color.substr(2, 2) + color.substr(0, 2)
}